property movieid, duration, movieLoc, movieL, movieT, movieR, movieB, moviePauseTime
global gSoundLevel

on birth me
  set movieid to EMPTY
  set duration to EMPTY
  set movieLoc to EMPTY
  set movieL to EMPTY
  set movieT to EMPTY
  set movieR to EMPTY
  set movieB to EMPTY
  set moviePauseTime to EMPTY
  return me
end

on QTPlay me
  if movieid <> EMPTY then
    set the soundLevel to gSoundLevel
    movieid(mPlay, 0, 0, EMPTY)
  end if
end

on QTPause me
  if movieid <> EMPTY then
    movieid(mStop)
    movieid(mGetTime)
    set moviePauseTime to integer(the result)
  end if
end

on QTDispose me
  if movieid <> EMPTY then
    if objectp(movieid) then
      movieid(mdispose)
    end if
    set movieid to EMPTY
    set duration to EMPTY
    set movieLoc to EMPTY
    set movieL to EMPTY
    set movieT to EMPTY
    set movieR to EMPTY
    set movieB to EMPTY
    set moviePauseTime to EMPTY
  end if
end

on QTIdle me
end

on QTOpenMovie me, theFilePath, theRect
  set movieid to batQT(mnew)
  movieid(mOpen, theFilePath, 0)
  movieid(mStop)
  movieid(mLength)
  set duration to integer(the result)
  set movieL to integer(item 1 of theRect)
  set movieT to integer(item 2 of theRect)
  set movieR to integer(item 3 of theRect)
  set movieB to integer(item 4 of theRect)
  movieid(mSetMovieBox, movieL, movieT, movieR, movieB)
end

on QTSetAudioLevel me, theLevel
  if movieid <> EMPTY then
    movieid(mSetVolume, 255)
  end if
end

on QTSetRect me, theRect
  set sL to integer(item 1 of theRect)
  set sT to integer(item 2 of theRect)
  set sR to integer(item 3 of theRect)
  set sB to integer(item 4 of theRect)
  movieid(mSetMovieBox, sL, sT, sR, sB)
end

on QTSetCurrTime me, theTime
  movieid(mSetVolume, 0)
  movieid(mSetTime, theTime)
  movieid(mPlay, 0, 0, EMPTY)
  movieid(mStop)
  movieid(mSetTime, theTime)
  movieid(mSetVolume, 255)
end

on QTSetTimeCallBack me, theHandle, theTime
  movieid(mAddCallBack, theTime)
end

on QTGetCurrtime me
  movieid(mGetTime)
  return integer(the result)
end

on QTgetrect me
  return movieid(mGetMovieBox)
end

on QTGetLoc me
  movieid(mGetMovieBox)
  set movieRect to string(the result)
  set movieLoc to item 1 to 2 of movieRect
  return movieLoc
end

on QTGetDuration me
  movieid(mLength)
  set duration to integer(the result)
  return duration
end

on qtrefresh me
  if movieid <> EMPTY then
    movieid(mSetMovieBox, movieL, movieT, movieR, movieB)
  end if
end

on QTaway me
  if movieid <> EMPTY then
    movieid(mSetMovieBox, -movieR - 640, -movieB - 480, -movieL - 640, -movieT - 480)
  end if
end

on QTreturn me
  if movieid <> EMPTY then
    movieid(mSetMovieBox, movieL, movieT, movieR, movieB)
  end if
end

on QTsetPauseTime me
  if movieid <> EMPTY then
    movieid(mStop)
    movieid(mSetTime, moviePauseTime)
  end if
end
